import type { Id } from '@feathersjs/feathers';
export declare function isDateAfterNow(date: number | Date, delay?: number): boolean;
export declare function deconstructId(token: string): string;
export declare function concatIDAndHash(id: Id, token: string): string;
export declare function ensureValuesAreStrings(...values: string[]): void;
/**
 * Verify that obj1 and obj2 have different 'field' field
 * Returns false if either object is null/undefined
 */
export declare function ensureFieldHasChanged(obj1: Record<string, unknown>, obj2: Record<string, unknown>): (field: string) => boolean;
export declare function ensureObjPropsValid(obj: Record<string, unknown>, props: string[], allowNone?: boolean): void;
export { getLongToken, getShortToken, randomBytes, randomDigits } from './crypto';
export { cloneObject } from './clone-object';
export { comparePasswords } from './compare-passwords';
export { getUserData } from './get-user-data';
export { hashPassword } from './hash-password';
export { notify } from './notify';
export { sanitizeUserForClient } from './sanitize-user-for-client';
export { sanitizeUserForNotifier } from './sanitize-user-for-notifier';
