"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addVerification = void 0;
var errors_1 = require("@feathersjs/errors");
var feathers_hooks_common_1 = require("feathers-hooks-common");
var helpers_1 = require("../helpers");
var options_1 = require("../options");
/**
 *
 * @param [path='authManagement'] the servicePath for your authManagement service
 * @returns
 */
function addVerification(path) {
    var _this = this;
    path = path || options_1.defaultPath; // default: 'authManagement'
    return function (context) { return __awaiter(_this, void 0, void 0, function () {
        var options_2, dataArray, err_1;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    (0, feathers_hooks_common_1.checkContext)(context, 'before', ['create', 'patch', 'update']);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    options_2 = context.app.service(path).options;
                    dataArray = (Array.isArray(context.data))
                        ? context.data
                        : [context.data];
                    if ((['patch', 'update'].includes(context.method)) &&
                        !!context.params.user &&
                        dataArray.some(function (data) {
                            return !options_2.identifyUserProps.some((0, helpers_1.ensureFieldHasChanged)(data, context.params.user));
                        })) {
                        return [2 /*return*/, context];
                    }
                    return [4 /*yield*/, Promise.all(dataArray.map(function (data) { return __awaiter(_this, void 0, void 0, function () {
                            var _a, longToken, shortToken;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0: return [4 /*yield*/, Promise.all([
                                            (0, helpers_1.getLongToken)(options_2.longTokenLen),
                                            (0, helpers_1.getShortToken)(options_2.shortTokenLen, options_2.shortTokenDigits)
                                        ])];
                                    case 1:
                                        _a = __read.apply(void 0, [_b.sent(), 2]), longToken = _a[0], shortToken = _a[1];
                                        data.isVerified = false;
                                        data.verifyExpires = Date.now() + options_2.delay;
                                        data.verifyToken = longToken;
                                        data.verifyShortToken = shortToken;
                                        data.verifyChanges = {};
                                        return [2 /*return*/];
                                }
                            });
                        }); }))];
                case 2:
                    _a.sent();
                    return [2 /*return*/, context];
                case 3:
                    err_1 = _a.sent();
                    throw new errors_1.GeneralError(err_1);
                case 4: return [2 /*return*/];
            }
        });
    }); };
}
exports.addVerification = addVerification;
