"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var errors_1 = require("@feathersjs/errors");
var debug_1 = __importDefault(require("debug"));
var helpers_1 = require("../helpers");
var debug = (0, debug_1.default)('authLocalMgnt:identityChange');
function identityChange(options, identifyUser, password, changesIdentifyUser, notifierOptions, params) {
    if (notifierOptions === void 0) { notifierOptions = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var usersService, usersServiceId, delay, identifyUserProps, longTokenLen, shortTokenLen, shortTokenDigits, passwordField, notifier, sanitizeUserForClient, users, user, err_1, _a, verifyToken, verifyShortToken, patchedUser, userResult;
        var _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    // note this call does not update the authenticated user info in hooks.params.user.
                    debug('identityChange', password, changesIdentifyUser);
                    if (params && "query" in params) {
                        params = Object.assign({}, params);
                        delete params.query;
                    }
                    usersService = options.app.service(options.service);
                    usersServiceId = usersService.id;
                    delay = options.delay, identifyUserProps = options.identifyUserProps, longTokenLen = options.longTokenLen, shortTokenLen = options.shortTokenLen, shortTokenDigits = options.shortTokenDigits, passwordField = options.passwordField, notifier = options.notifier, sanitizeUserForClient = options.sanitizeUserForClient;
                    (0, helpers_1.ensureObjPropsValid)(identifyUser, identifyUserProps);
                    (0, helpers_1.ensureObjPropsValid)(changesIdentifyUser, identifyUserProps);
                    return [4 /*yield*/, usersService.find(Object.assign({}, params, { query: Object.assign({}, identifyUser, { $limit: 2 }), paginate: false }))];
                case 1:
                    users = _c.sent();
                    user = (0, helpers_1.getUserData)(users);
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, (0, helpers_1.comparePasswords)(password, user[passwordField])];
                case 3:
                    _c.sent();
                    return [3 /*break*/, 5];
                case 4:
                    err_1 = _c.sent();
                    throw new errors_1.BadRequest('Password is incorrect.', { errors: (_b = {}, _b[passwordField] = 'Password is incorrect.', _b.$className = 'badParams', _b) });
                case 5: return [4 /*yield*/, Promise.all([
                        (0, helpers_1.getLongToken)(longTokenLen),
                        (0, helpers_1.getShortToken)(shortTokenLen, shortTokenDigits)
                    ])];
                case 6:
                    _a = __read.apply(void 0, [_c.sent(), 2]), verifyToken = _a[0], verifyShortToken = _a[1];
                    return [4 /*yield*/, usersService.patch(user[usersServiceId], {
                            verifyExpires: Date.now() + delay,
                            verifyToken: verifyToken,
                            verifyShortToken: verifyShortToken,
                            verifyChanges: changesIdentifyUser
                        }, Object.assign({}, params))];
                case 7:
                    patchedUser = _c.sent();
                    return [4 /*yield*/, (0, helpers_1.notify)(notifier, 'identityChange', patchedUser, notifierOptions)];
                case 8:
                    userResult = _c.sent();
                    return [2 /*return*/, sanitizeUserForClient(userResult)];
            }
        });
    });
}
exports.default = identityChange;
