"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resetPwdWithShortToken = exports.resetPwdWithLongToken = void 0;
var errors_1 = require("@feathersjs/errors");
var debug_1 = __importDefault(require("debug"));
var helpers_1 = require("../helpers");
var debug = (0, debug_1.default)('authLocalMgnt:resetPassword');
function resetPwdWithLongToken(options, resetToken, password, notifierOptions, params) {
    if (notifierOptions === void 0) { notifierOptions = {}; }
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    (0, helpers_1.ensureValuesAreStrings)(resetToken, password);
                    return [4 /*yield*/, resetPassword(options, { resetToken: resetToken }, { resetToken: resetToken }, password, notifierOptions, params)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.resetPwdWithLongToken = resetPwdWithLongToken;
function resetPwdWithShortToken(options, resetShortToken, identifyUser, password, notifierOptions, params) {
    if (notifierOptions === void 0) { notifierOptions = {}; }
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    (0, helpers_1.ensureValuesAreStrings)(resetShortToken, password);
                    (0, helpers_1.ensureObjPropsValid)(identifyUser, options.identifyUserProps);
                    return [4 /*yield*/, resetPassword(options, identifyUser, { resetShortToken: resetShortToken }, password, notifierOptions, params)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.resetPwdWithShortToken = resetPwdWithShortToken;
function resetPassword(options, identifyUser, tokens, password, notifierOptions, params) {
    if (notifierOptions === void 0) { notifierOptions = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var app, service, skipIsVerifiedCheck, reuseResetToken, passwordField, sanitizeUserForClient, notifier, usersService, usersServiceId, users, id, user_1, checkProps, user, tokenChecks, err_1, patchedUser, _a, _b, _c, _d, userResult;
        var _e;
        var _this = this;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    debug('resetPassword', identifyUser, tokens, password);
                    if (params && "query" in params) {
                        params = Object.assign({}, params);
                        delete params.query;
                    }
                    app = options.app, service = options.service, skipIsVerifiedCheck = options.skipIsVerifiedCheck, reuseResetToken = options.reuseResetToken, passwordField = options.passwordField, sanitizeUserForClient = options.sanitizeUserForClient, notifier = options.notifier;
                    usersService = app.service(service);
                    usersServiceId = usersService.id;
                    if (!tokens.resetToken) return [3 /*break*/, 2];
                    id = (0, helpers_1.deconstructId)(tokens.resetToken);
                    return [4 /*yield*/, usersService.get(id, Object.assign({}, params))];
                case 1:
                    user_1 = _f.sent();
                    users = [user_1];
                    return [3 /*break*/, 5];
                case 2:
                    if (!tokens.resetShortToken) return [3 /*break*/, 4];
                    return [4 /*yield*/, usersService.find(Object.assign({}, params, { query: Object.assign({}, identifyUser, { $limit: 2 }), paginate: false }))];
                case 3:
                    users = _f.sent();
                    return [3 /*break*/, 5];
                case 4: throw new errors_1.BadRequest('resetToken and resetShortToken are missing. (authLocalMgnt)', { errors: { $className: 'missingToken' } });
                case 5:
                    checkProps = skipIsVerifiedCheck ? ['resetNotExpired'] : ['resetNotExpired', 'isVerified'];
                    user = (0, helpers_1.getUserData)(users, checkProps);
                    tokenChecks = Object.keys(tokens).map(function (key) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!reuseResetToken) return [3 /*break*/, 1];
                                    // Comparing token directly as reused resetToken is not hashed
                                    if (tokens[key] !== user[key]) {
                                        throw new errors_1.BadRequest('Reset Token is incorrect. (authLocalMgnt)', {
                                            errors: { $className: 'incorrectToken' }
                                        });
                                    }
                                    return [3 /*break*/, 3];
                                case 1: return [4 /*yield*/, (0, helpers_1.comparePasswords)(tokens[key], user[key], function () {
                                        return new errors_1.BadRequest('Reset Token is incorrect. (authLocalMgnt)', { errors: { $className: 'incorrectToken' } });
                                    })];
                                case 2: return [2 /*return*/, _a.sent()];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    _f.label = 6;
                case 6:
                    _f.trys.push([6, 8, , 13]);
                    return [4 /*yield*/, Promise.all(tokenChecks)];
                case 7:
                    _f.sent();
                    return [3 /*break*/, 13];
                case 8:
                    err_1 = _f.sent();
                    if (!(user.resetAttempts > 0)) return [3 /*break*/, 10];
                    return [4 /*yield*/, usersService.patch(user[usersServiceId], {
                            resetAttempts: user.resetAttempts - 1
                        }, Object.assign({}, params))];
                case 9:
                    _f.sent();
                    throw err_1;
                case 10: return [4 /*yield*/, usersService.patch(user[usersServiceId], {
                        resetToken: null,
                        resetAttempts: null,
                        resetShortToken: null,
                        resetExpires: null
                    }, Object.assign({}, params))];
                case 11:
                    _f.sent();
                    throw new errors_1.BadRequest('Invalid token. Get for a new one. (authLocalMgnt)', { errors: { $className: 'invalidToken' } });
                case 12: return [3 /*break*/, 13];
                case 13:
                    _b = (_a = usersService).patch;
                    _c = [user[usersServiceId]];
                    _e = {};
                    _d = passwordField;
                    return [4 /*yield*/, (0, helpers_1.hashPassword)(app, password, passwordField)];
                case 14: return [4 /*yield*/, _b.apply(_a, _c.concat([(_e[_d] = _f.sent(),
                            _e.resetExpires = null,
                            _e.resetAttempts = null,
                            _e.resetToken = null,
                            _e.resetShortToken = null,
                            _e), Object.assign({}, params)]))];
                case 15:
                    patchedUser = _f.sent();
                    return [4 /*yield*/, (0, helpers_1.notify)(notifier, 'resetPwd', patchedUser, notifierOptions)];
                case 16:
                    userResult = _f.sent();
                    return [2 /*return*/, sanitizeUserForClient(userResult)];
            }
        });
    });
}
