"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.verifySignupWithShortToken = exports.verifySignupWithLongToken = void 0;
var errors_1 = require("@feathersjs/errors");
var debug_1 = __importDefault(require("debug"));
var helpers_1 = require("../helpers");
var debug = (0, debug_1.default)('authLocalMgnt:verifySignup');
function verifySignupWithLongToken(options, verifyToken, notifierOptions, params) {
    if (notifierOptions === void 0) { notifierOptions = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    (0, helpers_1.ensureValuesAreStrings)(verifyToken);
                    return [4 /*yield*/, verifySignup(options, { verifyToken: verifyToken }, { verifyToken: verifyToken }, notifierOptions, params)];
                case 1:
                    result = _a.sent();
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.verifySignupWithLongToken = verifySignupWithLongToken;
function verifySignupWithShortToken(options, verifyShortToken, identifyUser, notifierOptions, params) {
    if (notifierOptions === void 0) { notifierOptions = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    (0, helpers_1.ensureValuesAreStrings)(verifyShortToken);
                    (0, helpers_1.ensureObjPropsValid)(identifyUser, options.identifyUserProps);
                    return [4 /*yield*/, verifySignup(options, identifyUser, { verifyShortToken: verifyShortToken }, notifierOptions, params)];
                case 1:
                    result = _a.sent();
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.verifySignupWithShortToken = verifySignupWithShortToken;
function verifySignup(options, identifyUser, tokens, notifierOptions, params) {
    if (notifierOptions === void 0) { notifierOptions = {}; }
    return __awaiter(this, void 0, void 0, function () {
        function eraseVerifyProps(user, isVerified, verifyChanges, params) {
            return __awaiter(this, void 0, void 0, function () {
                var patchData, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            patchData = Object.assign({}, verifyChanges || {}, {
                                isVerified: isVerified,
                                verifyToken: null,
                                verifyShortToken: null,
                                verifyExpires: null,
                                verifyChanges: {}
                            });
                            return [4 /*yield*/, usersService.patch(user[usersServiceId], patchData, Object.assign({}, params))];
                        case 1:
                            result = _a.sent();
                            return [2 /*return*/, result];
                    }
                });
            });
        }
        var app, sanitizeUserForClient, service, notifier, usersService, usersServiceId, users, user, userErasedVerify, userResult;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    debug('verifySignup', identifyUser, tokens);
                    if (params && "query" in params) {
                        params = Object.assign({}, params);
                        delete params.query;
                    }
                    app = options.app, sanitizeUserForClient = options.sanitizeUserForClient, service = options.service, notifier = options.notifier;
                    usersService = app.service(service);
                    usersServiceId = usersService.id;
                    return [4 /*yield*/, usersService.find(Object.assign({}, params, { query: Object.assign({}, identifyUser, { $limit: 2 }), paginate: false }))];
                case 1:
                    users = _a.sent();
                    user = (0, helpers_1.getUserData)(users, [
                        'isNotVerifiedOrHasVerifyChanges',
                        'verifyNotExpired'
                    ]);
                    if (!!Object.keys(tokens).every(function (key) { return tokens[key] === user[key]; })) return [3 /*break*/, 3];
                    return [4 /*yield*/, eraseVerifyProps(user, user.isVerified)];
                case 2:
                    userErasedVerify = _a.sent();
                    throw new errors_1.BadRequest('Invalid token. Get for a new one. (authLocalMgnt)', { errors: { $className: 'badParam' } });
                case 3: return [4 /*yield*/, eraseVerifyProps(user, (0, helpers_1.isDateAfterNow)(user.verifyExpires), user.verifyChanges || {}, params)];
                case 4:
                    userErasedVerify = _a.sent();
                    _a.label = 5;
                case 5: return [4 /*yield*/, (0, helpers_1.notify)(notifier, 'verifySignup', userErasedVerify, notifierOptions)];
                case 6:
                    userResult = _a.sent();
                    return [2 /*return*/, sanitizeUserForClient(userResult)];
            }
        });
    });
}
