"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticationManagementService = void 0;
var debug_1 = __importDefault(require("debug"));
var errors_1 = require("@feathersjs/errors");
var options_1 = require("../options");
var check_unique_1 = __importDefault(require("../methods/check-unique"));
var identity_change_1 = __importDefault(require("../methods/identity-change"));
var password_change_1 = __importDefault(require("../methods/password-change"));
var resend_verify_signup_1 = __importDefault(require("../methods/resend-verify-signup"));
var reset_password_1 = require("../methods/reset-password");
var send_reset_pwd_1 = __importDefault(require("../methods/send-reset-pwd"));
var verify_signup_1 = require("../methods/verify-signup");
var verify_signup_set_password_1 = require("../methods/verify-signup-set-password");
var AuthenticationManagementBase_1 = require("./AuthenticationManagementBase");
var debug = (0, debug_1.default)('authLocalMgnt:service');
var AuthenticationManagementService = /** @class */ (function (_super) {
    __extends(AuthenticationManagementService, _super);
    function AuthenticationManagementService(app, options) {
        var _this = _super.call(this, app) || this;
        var defaultOptions = (0, options_1.makeDefaultOptions)();
        _this.options = Object.assign({}, defaultOptions, options);
        return _this;
    }
    AuthenticationManagementService.prototype._checkUnique = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, check_unique_1.default)(this.optionsWithApp, data.user, data.ownId, data.meta, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.checkUnique = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._checkUnique(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._identityChange = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, identity_change_1.default)(this.optionsWithApp, data.user, data.password, data.changes, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.identityChange = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._identityChange(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._passwordChange = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, password_change_1.default)(this.optionsWithApp, data.user, data.oldPassword, data.password, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.passwordChange = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._passwordChange(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._resendVerifySignup = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, resend_verify_signup_1.default)(this.optionsWithApp, data.user, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.resendVerifySignup = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._resendVerifySignup(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._resetPasswordLong = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, reset_password_1.resetPwdWithLongToken)(this.optionsWithApp, data.token, data.password, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.resetPasswordLong = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._resetPasswordLong(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._resetPasswordShort = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, reset_password_1.resetPwdWithShortToken)(this.optionsWithApp, data.token, data.user, data.password, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.resetPasswordShort = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._resetPasswordShort(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._sendResetPassword = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, send_reset_pwd_1.default)(this.optionsWithApp, data.user, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.sendResetPassword = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._sendResetPassword(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._verifySignupLong = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, verify_signup_1.verifySignupWithLongToken)(this.optionsWithApp, data.token, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.verifySignupLong = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._verifySignupLong(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._verifySignupShort = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, verify_signup_1.verifySignupWithShortToken)(this.optionsWithApp, data.token, data.user, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.verifySignupShort = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._verifySignupShort(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._verifySignupSetPasswordLong = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, verify_signup_set_password_1.verifySignupSetPasswordWithLongToken)(this.optionsWithApp, data.token, data.password, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.verifySignupSetPasswordLong = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._verifySignupSetPasswordLong(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._verifySignupSetPasswordShort = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var passedParams, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options.passParams;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.passParams(params)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        passedParams = _a;
                        return [4 /*yield*/, (0, verify_signup_set_password_1.verifySignupSetPasswordWithShortToken)(this.optionsWithApp, data.token, data.user, data.password, data.notifierOptions, passedParams)];
                    case 3: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype.verifySignupSetPasswordShort = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._verifySignupSetPasswordShort(data, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AuthenticationManagementService.prototype._create = function (data, params) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        debug("create called. action=".concat(data.action));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 25, , 27]);
                        if (!(data.action === 'checkUnique')) return [3 /*break*/, 3];
                        return [4 /*yield*/, this._checkUnique({
                                user: data.value,
                                meta: data.meta,
                                ownId: data.ownId
                            }, params)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        if (!(data.action === 'resendVerifySignup')) return [3 /*break*/, 5];
                        return [4 /*yield*/, this._resendVerifySignup({
                                user: data.value,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 4: return [2 /*return*/, _a.sent()];
                    case 5:
                        if (!(data.action === 'verifySignupLong')) return [3 /*break*/, 7];
                        return [4 /*yield*/, this._verifySignupLong({
                                token: data.value,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 6: return [2 /*return*/, _a.sent()];
                    case 7:
                        if (!(data.action === 'verifySignupShort')) return [3 /*break*/, 9];
                        return [4 /*yield*/, this._verifySignupShort({
                                token: data.value.token,
                                user: data.value.user,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 8: return [2 /*return*/, _a.sent()];
                    case 9:
                        if (!(data.action === 'verifySignupSetPasswordLong')) return [3 /*break*/, 11];
                        return [4 /*yield*/, this._verifySignupSetPasswordLong({
                                password: data.value.password,
                                token: data.value.token,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 10: return [2 /*return*/, _a.sent()];
                    case 11:
                        if (!(data.action === 'verifySignupSetPasswordShort')) return [3 /*break*/, 13];
                        return [4 /*yield*/, this._verifySignupSetPasswordShort({
                                password: data.value.password,
                                token: data.value.token,
                                user: data.value.user,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 12: return [2 /*return*/, _a.sent()];
                    case 13:
                        if (!(data.action === 'sendResetPwd')) return [3 /*break*/, 15];
                        return [4 /*yield*/, this._sendResetPassword({
                                user: data.value,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 14: return [2 /*return*/, _a.sent()];
                    case 15:
                        if (!(data.action === 'resetPwdLong')) return [3 /*break*/, 17];
                        return [4 /*yield*/, this._resetPasswordLong({
                                password: data.value.password,
                                token: data.value.token,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 16: return [2 /*return*/, _a.sent()];
                    case 17:
                        if (!(data.action === 'resetPwdShort')) return [3 /*break*/, 19];
                        return [4 /*yield*/, this._resetPasswordShort({
                                password: data.value.password,
                                token: data.value.token,
                                user: data.value.user,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 18: return [2 /*return*/, _a.sent()];
                    case 19:
                        if (!(data.action === 'passwordChange')) return [3 /*break*/, 21];
                        return [4 /*yield*/, this._passwordChange({
                                oldPassword: data.value.oldPassword,
                                password: data.value.password,
                                user: data.value.user,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 20: return [2 /*return*/, _a.sent()];
                    case 21:
                        if (!(data.action === 'identityChange')) return [3 /*break*/, 23];
                        return [4 /*yield*/, this._identityChange({
                                changes: data.value.changes,
                                password: data.value.password,
                                user: data.value.user,
                                notifierOptions: data.notifierOptions
                            }, params)];
                    case 22: return [2 /*return*/, _a.sent()];
                    case 23:
                        if (data.action === 'options') {
                            return [2 /*return*/, this.options];
                        }
                        _a.label = 24;
                    case 24: return [3 /*break*/, 27];
                    case 25:
                        err_1 = _a.sent();
                        return [4 /*yield*/, Promise.reject(err_1)];
                    case 26: return [2 /*return*/, _a.sent()];
                    case 27: throw new errors_1.BadRequest(
                    //@ts-expect-error action is of type never
                    // eslint-disable-next-line @typescript-eslint/restrict-template-expressions
                    "Action '".concat(data.action, "' is invalid."), { errors: { $className: 'badParams' } });
                }
            });
        });
    };
    return AuthenticationManagementService;
}(AuthenticationManagementBase_1.AuthenticationManagementBase));
exports.AuthenticationManagementService = AuthenticationManagementService;
